<template>
  <div id="myapp" class="app">
    <h1>Simon's game</h1>
    <p class="level">Level {{ level }}</p>
    <div class="game">
      <color-button
          v-for="color in colors"
          v-on:choose="clickColor(color)"
          v-bind:key="color"
          :color="color"/>
    </div>
    <div class="message">{{ message }}</div>
    <start-button :has-started="hasStarted" v-on:start="start()"/>
  </div>
</template>

<script>

import {playSound} from "@/helper/common";
import Start from "@/components/Start";
import Color from "@/components/Color";

const BASE_ATTEMPTS = 1;
const BASE_LEVEL = 1;

export default {
  components: {
    'start-button': Start,
    'color-button': Color
  },
  data: () => {
    return {
      level: BASE_LEVEL,
      colors: [
        {id: 1, name: "red", isHighlighted: false, sound: "../assets/sounds/colors/red.ogg"},
        {id: 2, name: "blue", isHighlighted: false, sound: "../assets/sounds/colors/blue.ogg"},
        {id: 3, name: "yellow", isHighlighted: false, sound: "../assets/sounds/colors/yellow.ogg"},
        {id: 4, name: "green", isHighlighted: false, sound: "../assets/sounds/colors/green.ogg"},
      ],
      attempts: BASE_ATTEMPTS,
      hasStarted: false,
      pattern: [],
      message: "Will you start the game?",
      loseSound: "assets/sounds/oof.mp3",
      winSound: "assets/sounds/pew.mp3"
    }
  },
  methods: {
    play: function () {
      this.pattern.forEach((e, i) => {
        let color = this.getColorById(e);

        setTimeout(() => {
          color.isHighlighted = true;
        }, i * 1000)

        setTimeout(() => {
          color.isHighlighted = false;
        }, (i + 1) * 950)
      })
    },
    getColorById: function (id) {
      return this.colors.find(color => {
        return color.id === id;
      });
    },
    start: function () {
      console.log('start');
      this.hasStarted = true;
      this.message = 'Game has started!';

      this.chooseRandomColor();
    },
    chooseRandomColor: function () {
      let color = this.getColorById(this.getRandomNumber(4));
      this.pattern.push(color.id);
      this.play();
    },
    getRandomNumber: function (max) {
      return Math.floor(Math.random() * max) + 1
    },
    clickColor: function (color) {
      if (color.id !== this.pattern[this.attempts - 1]) {
        this.message = "You lost! Try again.";
        playSound(this.loseSound);
        return this.resetGame();
      }

      if (this.attempts === this.pattern.length) {
        this.reachNextLevel()
        return;
      }

      this.attempts++;
    },
    reachNextLevel: function () {
      playSound(this.winSound);
      this.attempts = BASE_ATTEMPTS;
      this.level++;
      this.message = `Good job on reaching level ${this.level}`;
      this.chooseRandomColor();
    },
    resetGame: function () {
      this.attempts = BASE_ATTEMPTS;
      this.level = BASE_LEVEL;
      this.pattern = [];
      this.hasStarted = false;
      this.message = 'Will you start the game?';
    },
  }
}
</script>

<style>
@import '../css/index.css';
</style>